accounts/urls.py
from django.urls import path

from django.contrib.auth import views as auth_views


from accounts.views import signup


urlpatterns = [
    path("login/", auth_views.LoginView.as_view(), name="login"),
    path("logout/", auth_views.LogoutView.as_view(), name="logout"),
    path("signup/", signup, name="signup"),
]

projects/urls.py
from django.urls import path

from projects.views import (
    ProjectCreateView,
    ProjectListView,
    ProjectDetailView,
)

urlpatterns = [
    path("", ProjectListView.as_view(), name="list_projects"),
    path("<int:pk>/", ProjectDetailView.as_view(), name="show_project"),
    path("create/", ProjectCreateView.as_view(), name="create_project"),
]

tasks/urls.py
from django.urls import path

from tasks.views import TaskCreateView, TaskListView, TaskUpdateView

urlpatterns = [
    path("create/", TaskCreateView.as_view(), name="create_task"),
    path("mine/", TaskListView.as_view(), name="show_my_tasks"),
    path("<int:pk>/complete/", TaskUpdateView.as_view(), name="complete_task"),
]

tracker/urls.py
from django.contrib import admin
from django.urls import include, path

from django.views.generic.base import RedirectView


urlpatterns = [
    path("admin/", admin.site.urls),
    path("projects/", include("projects.urls")),
    path("accounts/", include("accounts.urls")),
    path("tasks/", include("tasks.urls")),
    path("", RedirectView.as_view(url="/projects/"), name="home"),
]

accounts/models.py
# from django.db import models

# Create your models here.

projects/models.py
from django.conf import settings
from django.db import models
from django.contrib.auth.models import User

# Create your models here.
USER_MODEL = settings.AUTH_USER_MODEL


# Create your models here.
class Project(models.Model):
    name = models.CharField(max_length=200)
    description = models.TextField()
    members = models.ManyToManyField(User, related_name="projects")

    def __str__(self):
        return str(self.name)

tasks/models.py
from django.db import models
from django.contrib.auth.models import User

# Create your models here.


class Task(models.Model):
    name = models.CharField(max_length=200)
    start_date = models.DateTimeField()
    due_date = models.DateTimeField()
    is_completed = models.BooleanField(default=False)
    project = models.ForeignKey(
        "projects.Project",
        related_name="tasks",
        on_delete=models.CASCADE,
    )
    assignee = models.ForeignKey(
        User, related_name="tasks", null=True, on_delete=models.SET_NULL
    )

    def __str__(self):
        return str(self.name)

accounts/views.py
from django.shortcuts import render, redirect
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User
from django.contrib.auth import login


# Create your views here.
def signup(request):
    if request.method == "POST":
        form = UserCreationForm(request.POST)
        if form.is_valid():

            username = request.POST["username"]
            password = request.POST["password1"]
            user = User.objects.create_user(username, password)
            user.save()
            login(request, user)
            return redirect("home")

    else:
        form = UserCreationForm(request.POST)
    context = {"form": form}
    return render(request, "registration/signup.html", context)

projects/views.py
from django.shortcuts import redirect
from django.urls import reverse_lazy
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView
from django.views.generic.list import ListView

from django.contrib.auth.mixins import LoginRequiredMixin
from projects.models import Project


class ProjectListView(LoginRequiredMixin, ListView):
    model = Project
    template_name = "projects/list.html"

    def get_queryset(self):
        return Project.objects.filter(members=self.request.user)


class ProjectDetailView(DetailView):
    model = Project
    template_name = "projects/detail.html"


class ProjectCreateView(LoginRequiredMixin, CreateView):  # LoginRequiredMixin
    model = Project
    template_name = "projects/create.html"
    fields = [
        "name",
        "description",
        "members",
    ]

    success_url = reverse_lazy("home")

    def form_valid(self, form):

        item = form.save(commit=False)
        item.save()
        form.save_m2m()
        return redirect("show_project", item.pk)

tasks/views.py
from django.urls import reverse_lazy
from django.views.generic.edit import CreateView, UpdateView
from django.views.generic.list import ListView
from django.contrib.auth.mixins import LoginRequiredMixin
from tasks.models import Task


class TaskCreateView(LoginRequiredMixin, CreateView):  # LoginRequiredMixin
    model = Task
    template_name = "tasks/create.html"
    fields = [
        "name",
        "start_date",
        "due_date",
        "project",
        "assignee",
    ]

    success_url = reverse_lazy("show_project")

    def get_success_url(self) -> str:
        return reverse_lazy("show_project", args=[self.object.id])

    def form_valid(self, form):
        item = form.save(commit=False)
        item.members = self.request.user
        item.save()

        return super().form_valid(form)


class TaskListView(LoginRequiredMixin, ListView):
    model = Task
    template_name = "tasks/mine.html"

    def get_queryset(self):
        return Task.objects.filter(assignee=self.request.user)


class TaskUpdateView(LoginRequiredMixin, UpdateView):
    model = Task
    template_name = "tasks/mine.html"
    fields = ["is_completed"]
    success_url = reverse_lazy("show_my_tasks")

projects/templates/base.html
{% load static %}

<!DOCTYPE html>
<html lang="en">

    <head>
        <meta charset="UTF-8">
        <title>Projects</title>
        <link rel="stylesheet" href="{% static 'css/app.css' %}">
    </head>

    <body>
        <header>
            <nav>
                <ul>
                    {% if user.is_authenticated %}
                        <li>
                            <a href="{% url 'show_my_tasks' %}">My tasks</a>
                        </li>
                        <li>
                            <a href="{% url 'list_projects' %}">My projects</a>
                        </li>
                        <li>
                            <a href="{% url 'logout' %}">Logout</a>
                        </li>
                    {% else%}
                        <li>
                            <a href="{% url 'login' %}">Login</a>
                        </li>
                        <li>
                            <a href="{% url 'signup' %}">Sign Up</a>
                        </li>

                    {% endif %}

                </ul>
            </nav>
        </header>
        {% block content %}
        {% endblock content %}
    </body>

</html>

projects/templates/projects/create.html
{% extends 'base.html' %}
{% block content %}

    <main class="todos-form">
        <div>
            <h1>Create a new project </h1>
            <form method="post">
                {% csrf_token %}
                {{ form.as_p }}
                <div class="control">
                    <button class="button">Create</button>
                </div>
            </form>
        </main>
{% endblock content %}

projects/templates/projects/detail.html
{% extends 'base.html' %}
{% block content %}

    {% load markdownify %}



    {% comment %} {% load markdownify %}
{% load resizer%} {% endcomment %}
    <main>
        <div>
            <h1> {{project.name}} </h1>
            {{ project.description|markdownify }}
            <h2> Tasks </h2>

            <li>
                <a href="{% url 'create_task' %}">Create a new task</a>
            </li>


            {% if  project.tasks.all|length == 0 %}


                <p>This project has no tasks</p>

            {%else%}

                <table>
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>Assignee</th>
                            <th>Start date</th>
                            <th>Due date</th>
                            <th>Is completed</th>
                        </tr>
                    </thead>
                    <tbody>

                        {% for task in project.tasks.all %}
                            <tr>
                                <td>  {{task.name}} </td>

                                <td> {{task.assignee}} </td>
                                <td>  {{task.start_date}} </td>
                                <td> {{task.due_date}} </td>
                                <td>  {{task.is_completed}} </td>
                            </tr>


                        {% endfor %}

            {%endif%}

        </div>
    </main>
{% endblock content %}

projects/templates/projects/list.html
{% extends 'base.html' %}


{% block content %}

    <main >
        <div>
            <h1> My Projects </h1>

            <li>
                <a href="{% url 'create_project' %}">Create a new project</a>
            </li>


            {% if  project_list|length == 0 %}

                <p>You are not assigned to any projects</p>

            {%else%}

                <table>
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>Number of tasks</th>

                        </tr>
                    </thead>
                    <tbody>



                        {% for project in project_list %}
                            <tr>
                                <td>        <a href="{% url 'show_project' project.pk %}">{{ project.name }}</a>
                                </td>
                                <td> {{project.tasks.all|length}} </td>
                            </tr>

                        {% endfor %}
                    </tbody>
                </table>
            {%endif%}
        </div>
    </main>
{% endblock content %}

tasks/templates/tasks/create.html
{% extends 'base.html' %}
{% block content %}

    <main class="todos-form">
        <div>
            <h1>Create a new task </h1>
            <form method="post">
                {% csrf_token %}
                {{ form.as_p }}
                <div class="control">
                    <button class="button">Create</button>
                </div>
            </form>
        </main>
{% endblock content %}

tasks/templates/tasks/mine.html
{% extends 'base.html' %}
{% block content %}

    <main >
        <div>
            <h1> My Tasks </h1>
            {% if  task_list|length == 0 %}
                <p>You have no tasks</p>
            {%else%}

                <table>
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>Start date</th>
                            <th>Due date</th>
                            <th>Is completed</th>
                        </tr>
                    </thead>
                    <tbody>

                        {% for task in task_list %}
                            <tr>
                                <td>  {{task.name}} </td>
                                <td>  {{task.start_date}} </td>
                                <td> {{task.due_date}} </td>

                                <td>  {% if task.is_completed == False%}
                                    <form method="post" action="{% url 'complete_task' task.id %}">
                                        {% csrf_token %}
                                        <input type="hidden" name="is_completed" value="True">
                                        <button>Complete</button>
                                    </form>

                                {% else %}
                                    {{ task.is_completed|yesno:"Done,no,maybe" }}

                                {% endif %}
                                </td>
                            </tr>
                        {% endfor %}
                    </tbody>
                </table>
            {%endif%}
        </div>
    </main>
{% endblock content %}